<?php

/**
* Plugin zum Verwalten von Terminbuchungen auf der Homepage
*
* @author               Jan Kulmann <jankul@zmml.uni-bremen.de>
*
*/

// +---------------------------------------------------------------------------+
// This file is NOT part of Stud.IP
// Copyright (C) 2010 Jan Kulmann <jankul@zmml.uni-bremen.de>
// ATTENTION: Please send ALL bug reports and security leaks directly to the author.
//            Thx!
// +---------------------------------------------------------------------------+
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or any later version.
// +---------------------------------------------------------------------------+
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// +---------------------------------------------------------------------------+


$GLOBALS['sess']->register('open_cat');

require_once ("lib/functions.php");
require_once ("lib/calendar_functions.inc.php");
require_once ("classes/TVDBM.class.php");

class HomepageterminvergabePlugin extends AbstractStudIPHomepagePlugin {

	private $userid;
	private $username;
	public  $open_cat;
	public  $new_category_id;
	public  $verify_classes = array();
	public  $php_tage_short;
	public  $dbm;
	public  $factory;

	function HomepageterminvergabePlugin(){
		parent::AbstractStudIPHomepagePlugin();
		bindtextdomain('tv',dirname(__FILE__).'/locale');
		$this->php_tage_short = array("1"=>dgettext("tv","Mo"), "2"=>dgettext('tv',"Di"), "3"=>dgettext('tv',"Mi"), "4"=>dgettext('tv',"Do"), "5"=>dgettext('tv',"Fr"), "6"=>dgettext('tv',"Sa"), "0"=>dgettext('tv',"So"));
		$this->factory = new Flexi_TemplateFactory(dirname(__FILE__).'/templates');
		$this->setPluginIconName('images/termine.gif');
		$this->open_cat = & $GLOBALS['open_cat'];
		if (!is_array($this->open_cat)) $this->open_cat = array();
		include ("TVConfig.inc.php");
		foreach ($VERIFY as $v) {
			require_once 'classes/Verify'.$v.'.class.php';
			$cname = 'Verify'.$v;
			$this->verify_classes[$cname] = new $cname;
		}
		$this->dbm = new TVDBM(&$this);
	}
	
	function setPluginpath($newpath){
		parent::setPluginpath($newpath);
		$this->buildMenu();
	}
	
	function buildMenu(){
		$tab = new PluginNavigation();
		$tab->setDisplayname(dgettext('tv',"Terminvergabe"));
		$tab->setActive();
		$subnav = new PluginNavigation();
		$subnav->setDisplayname(dgettext('tv',"Neue Termingruppe anlegen"));
		$subnav->setActive();
		$subnav->addLinkParam("tmodus2","show_cat_form");
		$tab->addSubmenu($subnav);
		$subnav2 = new PluginNavigation();
		$subnav2->setDisplayname(dgettext('tv',"Wo bin ich gebucht?"));
		$subnav2->setActive();
		$subnav2->addLinkParam("tmodus2","show_bookings");
		$tab->addSubmenu($subnav2);
		$this->setNavigation($tab); 
	}

	function setRequestedUser($user) {
                parent::setRequestedUser($user);
                $u = $this->getRequestedUser();
		if (!$this->dbm) $this->dbm = new TVDBM(&$this);
                $this->setStatusShowOverviewPage($this->dbm->has_valid_entries($u->getUserId()));
        }

	function getStyle() {
		echo "<script type=\"text/javascript\" src=\"".$GLOBALS['ASSETS_URL']."/javascripts/builder.js\"></script>\n";
		echo "<LINK REL=\"stylesheet\" HREF=\"".$this->getPluginURL()."/css/style.css\" TYPE=\"text/css\" />\n";
	}

	function getLink($obj, $linkparams, $view=null) {
                $linkparams['1'] = 1;
                return PluginEngine::getLink($obj,$linkparams, $view);
        }

	function show_category_form($cat_id=FALSE) {
		$c = array();
		if ($cat_id) {
			$c = $this->dbm->getCategory($cat_id);
			/*$c['bemerkungen'] = htmlReady($c['bemerkungen']);
			$c['zusatz_text'] = htmlReady($c['zusatz_text']);
			$c['titel'] = htmlReady($c['titel']);*/
		}

		$va_ids = array();
		foreach ($this->dbm->getCategorySeminare($cat_id) as $v)
			$va_ids[] = $v['Seminar_id'];
		$template = $this->factory->open('category_form');
                $template->set_attribute('plugin_url',$this->getPluginURL());
                $template->set_attribute('uri', $this->getLink($this,array()));
		$template->set_attribute('ajax_uri', $this->getLink($this,array(),'ajaxdispatch'));
                $template->set_attribute('cat_id', $cat_id);
                $template->set_attribute('vas', $this->dbm->getSeminare());
                $template->set_attribute('va_ids', $va_ids);
                $template->set_attribute('cat_vas', $this->dbm->getCategorySeminare($cat_id));
		$template->set_attribute('is_root', $GLOBALS['perm']->have_perm("root"));
                $template->set_attribute('c', $c);
                $template->set_attribute('verify_classes', &$this->verify_classes);
                echo $template->render();
	}

	function show_message_form($cat_id, $termin_id=null) {
		$studipticket = Seminar_Session::get_ticket();

		$help_url=format_help_url("Basis.VerschiedenesFormat");

		$GLOBALS['sess']->register('persons');
		$persons = &$GLOBALS['persons'];
		if ($_REQUEST['reset']=='yes') {
			$persons = array();
			if ($termin_id) $persons = $this->dbm->get_registered_persons($termin_id);
			else $persons = $this->dbm->get_registered_persons_cat($cat_id);
		}
		if (is_array($_REQUEST['rcv_adr']) && count($_REQUEST['rcv_adr']) > 0 && $_REQUEST['remove_rcpt'] == "yes") {
			$tmp = array();
			foreach ($persons as $p) {
				if (!in_array($p['user_id'], $_REQUEST['rcv_adr']))
					array_push($tmp, $p);
			}
			$persons = $tmp;
		}
		$template = $this->factory->open('mailform');
                $template->set_attribute('img_uri', $this->getPluginURL().'/images/');
                $template->set_attribute('uri', $this->getLink($this,array()));
                $template->set_attribute('cat_id', $cat_id);
                $template->set_attribute('termin_id', $termin_id);
                $template->set_attribute('studipticket', $studipticket);
                $template->set_attribute('persons', $persons);
                $template->set_attribute('help_url', $help_url);
                echo $template->render();
	}

	function show_booking_list($user_id) {
		$cssSw=new cssClassSwitcher;

		$t = array();
		foreach ($this->dbm->getUsersBookingList($user_id) as $d) {
			$cssSw->switchClass();
			$a = array();
			$a['class'] = $cssSw->getClass();
			$a['titel'] = stripslashes($d['titel']);
			$a['tag'] = date("d.m.Y",$d["von"]);
			$a['von'] = date("H:i",$d["von"]);
			$a['bis'] = date("H:i",$d['bis']);
			$a['ort'] = $d["ort"];
			$a['zusatz'] = stripslashes($d["zusatz"]);
			$a['iconlink'] = ((!$d['enddate_admission'] || time() < $d['enddate_admission']) && (!$d['t_enddate_admission'] || time() < $d['t_enddate_admission']) ?
				"<A HREF=\"".$this->getLink($this,array("tmodus"=>"unjoin","termin_id"=>$d["termin_id"],"tmodus2"=>Request::option('tmodus2')))."\"><IMG SRC=\"".$GLOBALS['ASSETS_URL']."/images/logout_seminare.gif\" TITLE=\"".dgettext('tv','austragen')."\" ALT=\"".dgettext('tv','austragen')."\" BORDER=\"0\"></A>" :
				"<IMG SRC=\"".$GLOBALS['ASSETS_URL']."/images/closelock2.gif\" TITLE=\"".dgettext('tv','An-/Abmeldezeitraum abgelaufen')."\" ALT=\"".dgettext('tv','An-/Abmeldezeitraum abgelaufen')."\">"
				);
			$a['autorlink'] = "<A HREF=\"".$GLOBALS['ABSOLUTE_URI_STUDIP']."/about.php?username=".get_username($d["autor_id"])."\">".htmlReady(get_fullname($d["autor_id"]))."</A>";
			array_push($t, $a);
		}
		$template = $this->factory->open('booking_list');
       	        $template->set_attribute('t', $t);
               	echo $template->render();
	}

	function show_category_listing($user_id) {
		$tmodus = Request::option('tmodus');
		$category_id = Request::option('category_id');
		if (count($cats = $this->dbm->getCategoriesByUser($user_id))) {
			$template = $this->factory->open('show_category_listing');
			$template->set_attribute('cats', $cats);
			$template->set_attribute('plugin', &$this);
			$template->set_attribute('tmodus', $tmodus);
			$template->set_attribute('cssSw', new cssClassSwitcher);
			$template->set_attribute('category_id', $category_id);
			echo $template->render();

		} else {
			StudIPTemplateEngine::showInfoMessage(dgettext('tv',"Sie haben noch keine Termingruppen angelegt."));
		}
	}

	function show_public_termine($user_id) {
		$u = new StudIPUser();
		$u = $this->getRequestedUser();
		$this->userid = $u->getUserId();
		$this->username = $u->getUsername();
		$open = Request::option('t_open');

		$cssSw=new cssClassSwitcher;
		$cssSw->hoverenabled = TRUE;
		$cats = $this->dbm->getCategoriesByUser($user_id, TRUE);
		if (count($cats)) {
			$template = $this->factory->open('show_public_termine');
			$template->set_attribute('cats', $cats);
			$template->set_attribute('uri', "about.php?username=".$this->username);
			$template->set_attribute('plugin', &$this);
			$template->set_attribute('open', $open);
			$template->set_attribute('cssSw', &$cssSw);
			$template->set_attribute('username', $this->username);
			echo $template->render();
		}
	}


	function show_termine_form($category_id) {
		$template = $this->factory->open('termine_form');
                $template->set_attribute('plugin_url',$this->getPluginURL());
                $template->set_attribute('uri', $this->getLink($this,array()));
                $template->set_attribute('category_id', $category_id);
                echo $template->render();
	}
	
	function show_create_termine($termine, $category_id) {
		// wurden korrekte Termien generiert?
		if (count($termine) > 0) {
			$cssSw=new cssClassSwitcher;
			foreach ($termine as &$t) {
				$cssSw->switchClass();
				$t['class'] = $cssSw->getClass();
				$t['von'] = $t[0];
				$t['bis'] = $t[1];
				$t['von_txt'] = date("H:i", $t[0]);
				$t['bis_txt'] = date("H:i", $t[1]);
				$t['ort'] = htmlReady($_REQUEST['ort']);
				$t['anz_pers'] = htmlReady(Request::option('anz_pers'));
				$t['holiday'] = (holiday($t['von']) ? holiday($t['von']) : "");
				$ovl = $this->dbm->get_overlapped_dates($t[0], $t[1]);
				$t['overlapp'] = $ovl;
				$t['tooltip'] = tooltip(dgettext('tv',"berschneidung mit folgenden Terminen gefunden:")."\n".$this->dbm->get_overlapped_dates_txt($ovl),FALSE,TRUE);
				$t['uri'] = $this->getPluginURL();
			}
			$template = $this->factory->open('create_termine');
        	        $template->set_attribute('plugin',&$this);
        	        $template->set_attribute('termine',$termine);
                	$template->set_attribute('uri', $this->getLink($this,array()));
	                $template->set_attribute('category_id', $category_id);
        	        echo $template->render();
		}
	}

	function show_termin_edit_form($termin_id, $category_id) {
		$t = $this->dbm->getTermin($termin_id);;
		$t['von_d'] = date('d',$t['von']);
		$t['von_m'] = date('m',$t['von']);
		$t['von_y'] = date('Y',$t['von']);
		$t['von_h'] = date('H',$t['von']);
		$t['von_i'] = date('i',$t['von']);
		$t['bis_h'] = date('H',$t['bis']);
		$t['bis_i'] = date('i',$t['bis']);

		$template = $this->factory->open('termin_edit_form');
                $template->set_attribute('plugin_url',$this->getPluginURL());
                $template->set_attribute('uri', $this->getLink($this,array()));
                $template->set_attribute('category_id', $category_id);
                $template->set_attribute('termin_id', $termin_id);
                $template->set_attribute('t', $t);
                echo $template->render();
	}

	function show() {
		$GLOBALS['perm']->check('autor');
		$this->showAdministrationPage();
	}

	function actionShowAdministrationPage() {
		$GLOBALS['perm']->check('autor');
		$this->showAdministrationPage();
	}

	function showAdministrationPage(){
		$GLOBALS['perm']->check('autor');

		$this->getStyle();

		$u = new StudIPUser();
		$u = $this->getRequestedUser();
		$this->userid = $u->getUserId();
		$this->username = $u->getUsername();
		$tmodus = Request::option('tmodus');
		$category_id = Request::option('category_id');

		$close = Request::option('c_close');
		$open  = Request::option('c_open');
		if ($close && is_array($this->open_cat)) {
			$tmp_arr = array();
                        foreach ($this->open_cat as $v)
                                if ($v != $close)
		                        array_push($tmp_arr, $v);
                        $this->open_cat = $tmp_arr;
                }
                if ($open && !in_array($open, $this->open_cat)) array_push($this->open_cat, $open);

		if ($this->userid == $GLOBALS['auth']->auth['uid'] || $GLOBALS['perm']->have_perm('root')) {
			if ($tmodus == "show_cat_form" || Request::option('tmodus2') == "show_cat_form") {
				$this->show_category_form($category_id);
			}
			if ($tmodus == "show_add_termine") {
				unset($tmodus);
			}
			if ($tmodus == "send_message") {
				if (trim($_REQUEST['subject']) == "" || trim($_REQUEST['content']) == "") {
					StudIPTemplateEngine::showErrorMessage(dgettext('tv',"Bitte f&uuml;llen Sie alle Pflichtfelder aus!"));
					$tmodus = "show_message_form";
				} else {
					$anz = $this->dbm->send_messages($_REQUEST['rcv_adr'], trim($_REQUEST['subject']), trim($_REQUEST['content']), ($_REQUEST['force_mail_forward'] == "yes" ? TRUE : FALSE));
					StudIPTemplateEngine::showSuccessMessage(sprintf(dgettext('tv',"%d Nachricht(en) wurde(n) verschickt."),$anz));
					unset($tmodus);
				}
			}
			if ($tmodus == "show_message_form") {
				$this->show_message_form($category_id, Request::option('termin_id'));
			}
			if ($tmodus == "edit_termin") {
				if ($_REQUEST['termin_id']) {
					$termin = $this->dbm->getTermin(Request::option('termin_id'),$GLOBALS['auth']->auth['uid']);
					if ($termin || $GLOBALS['perm']->have_perm('root')) {
						$this->show_termin_edit_form(Request::option('termin_id'), $category_id);
					}
				}
			}
			if ($tmodus == "save_category") {
				$unique_entry = ($_REQUEST['unique_entry'] == 1 ? 1 : 0);
				$zusatz_active = ($_REQUEST['zusatz_active'] == 'yes' ? 1 : 0);
				$zusatz_mandatory = ($_REQUEST['zusatz_mandatory'] == 'yes' ? 1 : 0);
				$zusatz_verify = Request::option('zusatz_verify');
				if (!array_key_exists($zusatz_verify, $this->verify_classes)) $zusatz_verify = '';
				$zusatz = trim($_REQUEST['zusatz']);
				$ende = 0;
				$seminar_ids = $_REQUEST['seminar_ids'];
				if (!is_array($seminar_ids) || !count($seminar_ids)) $seminar_ids = FALSE;
				if (Request::option('end_t') && Request::option('end_m') && Request::option('end_j') && Request::option('end_h') && Request::option('end_i'))
					$ende = mktime(Request::option('end_h'), Request::option('end_i'), 0, Request::option('end_m'), Request::option('end_t'), Request::option('end_j'));
				if ($category_id) {
					if (trim($_REQUEST['cat_name']))
						$this->dbm->updateCategory($unique_entry,trim($_REQUEST['cat_name']),trim($_REQUEST['cat_desc']), Request::option('visible'), $seminar_ids, $ende, $zusatz_active, $zusatz, $zusatz_mandatory, $zusatz_verify, $this->userid, $category_id);
				} else {
					$new_id = md5(uniqid(time()));
					if (trim($_REQUEST['cat_name']))
						$this->dbm->createCategory($new_id,mysql_escape_string(trim($_REQUEST['cat_name'])),mysql_escape_string(trim($_REQUEST['cat_desc'])), Request::option('visible'), $unique_entry, $seminar_ids, $ende, $zusatz_active, mysql_escape_string($zusatz), $zusatz_mandatory, mysql_escape_string($zusatz_verify));
					$this->new_category_id = $new_id;
					if (!in_array($this->new_category_id, $this->open_cat)) array_push($this->open_cat, $this->new_category_id);
				}
				StudIPTemplateEngine::showSuccessMessage(dgettext('tv',"Die Termingruppe wurde gespeichert."));
				unset($tmodus);
			}
			if ($tmodus == "create_termine") {
				$this->show_create_termine($this->dbm->generate_termine($category_id), $category_id);
			}
			if ($tmodus == "create_termine_really") {
				$von = $_REQUEST['von'];
				$ort = $_REQUEST['ort'];
				$von_h = $_REQUEST['von_h'];
				$von_i = $_REQUEST['von_i'];
				$bis_h = $_REQUEST['bis_h'];
				$bis_i = $_REQUEST['bis_i'];
				$anz_pers = $_REQUEST['anz_pers'];
				$create = $_REQUEST['create'];
				$count = 0;
				if (is_array($von) && is_array($ort) && is_array($anz_pers) && is_array($create) && 
						($this->dbm->get_owner_of_category($category_id)==$GLOBALS['auth']->auth['uid'] || $GLOBALS['perm']->have_perm('root'))) {
					for ($i=0; $i<count($create); $i++) {
						if ($_REQUEST['create'.'_'.$i] == "yes") {
							$von_t = mktime($von_h[$i], $von_i[$i],0,date('m',$von[$i]),date('d',$von[$i]),date('Y',$von[$i]));
							$bis_t = mktime($bis_h[$i], $bis_i[$i],0,date('m',$von[$i]),date('d',$von[$i]),date('Y',$von[$i]));
							if ($von_t < $bis_t) {
								$count ++;
								$new_id = md5(uniqid(time()));
								$this->dbm->createTermin($new_id, $category_id, $von_t, $bis_t, $ort[$i], $anz_pers[$i]);
							}
						}
					}
				}
				StudIPTemplateEngine::showSuccessMessage(sprintf(dgettext('tv',"%d Termin(e) wurde(n) angelegt."),$count));
				unset($tmodus);
			}
			if ($tmodus == "save_termin") {
				$von = mktime(Request::option('von_h'),Request::option('von_i'),0,Request::option('von_m'),Request::option('von_t'),Request::option('von_j'));
				$bis = mktime(Request::option('bis_h'),Request::option('bis_i'),0,Request::option('von_m'),Request::option('von_t'),Request::option('von_j'));
				$ende = 0;
				if (Request::option('end_t') && Request::option('end_m') && Request::option('end_j') && Request::option('end_h') && Request::option('end_i'))
					$ende = mktime(Request::option('end_h'), Request::option('end_i'), 0, Request::option('end_m'), Request::option('end_t'), Request::option('end_j'));
				$termin = $this->dbm->getTermin(Request::option('termin_id'),$GLOBALS['auth']->auth['uid']);
                                if ($termin || $GLOBALS['perm']->have_perm('root')) {
					$this->dbm->updateTermin($von, $bis, $_REQUEST['ort'], Request::option('anz_pers'), $ende, Request::option('termin_id'));
					StudIPTemplateEngine::showSuccessMessage(dgettext('tv',"Der Termin wurde aktualisiert."));
				}
				unset($tmodus);
			}
			if ($tmodus == "delete_termin") {
				$template = $this->factory->open('yes_no_dlg');
		                $template->set_attribute('question_text',dgettext('tv',"Soll der Termin wirklich gel&ouml;scht werden?"));
				$template->set_attribute('yes_link', $this->getLink($this,array("tmodus"=>"delete_termin_really","termin_id"=>Request::option('termin_id'))));
				$template->set_attribute('no_link', $this->getLink($this,array()));
				echo $template->render();
				unset($tmodus);
			}
			if ($tmodus == "delete_termin_really") {
				$this->dbm->removeTermin(Request::option('termin_id'));
				StudIPTemplateEngine::showSuccessMessage(dgettext('tv',"Der Termin wurde gel&ouml;scht!"));
				unset($tmodus);
			}
			if ($tmodus == "multi_delete_termine") {
				$termine = $_REQUEST['del_termine'];
				if (is_array($termine)) {
					$template = $this->factory->open('multi_delete_termine_form');
					$template->set_attribute('termine',$termine);
					$template->set_attribute('delete_uri', $this->getLink($this,array("tmodus"=>"multi_delete_termine_really")));
					$template->set_attribute('no_uri', $this->getLink($this,array()));
					$template->set_attribute('category_id', $category_id);
					echo $template->render();
				}
				unset($tmodus);
			}
			if ($tmodus == "multi_delete_termine_really") {
				$termine = $_REQUEST['del_termine'];
				if (is_array($termine)) {
					foreach ($termine as $termin_id) {
						$this->dbm->removeTermin($termin_id);
					}
					StudIPTemplateEngine::showSuccessMessage(dgettext('tv',"Die gew&auml;hlten Termine wurden gel&ouml;scht!"));
				}
				unset($tmodus);
			}
			if ($tmodus == "delete_category") {
				$template = $this->factory->open('yes_no_dlg');
		                $template->set_attribute('question_text',dgettext('tv',"Soll die Termingruppe mit allen Termineintr&auml;gen und Buchungen wirklich gel&ouml;scht werden?"));
				$template->set_attribute('yes_link', $this->getLink($this,array("tmodus"=>"delete_category_really","category_id"=>$category_id)));
				$template->set_attribute('no_link', $this->getLink($this,array()));
				echo $template->render();
			}
			if ($tmodus == "delete_category_really") {
				if ($this->dbm->get_owner_of_category($category_id)==$GLOBALS['auth']->auth['uid'] || $GLOBALS['perm']->have_perm('root')) {
					$this->dbm->removeCategory($category_id);
					StudIPTemplateEngine::showSuccessMessage(dgettext('tv',"Die Termingruppe wurde gel&ouml;scht!"));
				}
				unset($tmodus);
			}
			if ($tmodus == "unjoin" && $this->dbm->has_joined(Request::option('termin_id'))) {
				$t = $this->dbm->getCategoryFromTermin(Request::option('termin_id'));
				if ($t) {
					if (!$t['enddate_admission'] || time() < $t['enddate_admission']) {
						$this->dbm->remove_person_from_termin(Request::option('termin_id'),$GLOBALS['auth']->auth['uid']);
						StudIPTemplateEngine::showSuccessMessage(dgettext('tv',"Sie haben sich erfolgreich ausgetragen!"));
					} else {
						StudIPTemplateEngine::showErrorMessage(dgettext('tv',"Sie k&ouml;nnen sich nicht austragen, der Abmeldezeitraum ist abgelaufen!"));
					}
				}
				unset($tmodus);
			}
			if ($tmodus == "remove_admission" && Request::option('termin_id') && Request::option('remove_username')) {
				$t = $this->dbm->getTerminWithCategoryData(Request::option('termin_id'));
				if ($t) {
					if ($t["user_id"] == $GLOBALS['auth']->auth['uid'] || $GLOBALS['perm']->have_perm('root')) {
						// Gehoert der Termin uebrhaupt zu meinen oder bin ich ein Root?
						$user_id = get_userid(Request::option('remove_username'));
						if ($user_id) {
							$this->dbm->remove_person_from_termin(Request::option('termin_id'),$user_id);
							StudIPTemplateEngine::showSuccessMessage(dgettext('tv',"Die Person wurde ausgetragen und dar&uuml;ber benachrichtigt!"));
							$m = new messaging;
							$message = sprintf(dgettext('tv',"Sie wurden von dem Eigentuemer (%s) bzw. einem Administrator aus einem Termin (%s am %s, %s Uhr) ausgetragen!\n\n"),htmlReady(get_fullname($t['user_id'])),$t['titel'],date('d.m.Y',$t['von']),(date('H:i',$t['von']).' - '.date('H:i',$t['bis'])));
							$m->insert_message($message, Request::option('remove_username'), "____%system%____", FALSE, FALSE, 1, FALSE, dgettext('tv',"Termineintrag gelscht"));
						}
					}
				}
				unset($tmodus);
			}
	
			if (!$tmodus && !$_REQUEST['tmodus2']) {
				$this->show_category_listing($this->userid);
			}
			if (!$tmodus && $_REQUEST['tmodus2'] == "show_bookings") {
				$this->show_booking_list($this->userid);
			}
		} else {
			StudIPTemplateEngine::showErrorMessage(dgettext('tv',"Zugriff verweigert!"));
		}
	}

	function showOverview() {
		$GLOBALS['perm']->check('autor');
		$tmodus = Request::option('tmodus');
		$u = new StudIPUser();
		$u = $this->getRequestedUser();
		$this->userid = $u->getUserId();
		$this->username = $u->getUsername();
		$category_id = Request::option('t_open');
		
		echo "<A NAME=\"t_anker\" />\n";

		if (Request::option('termin_id') != "") {
			$c = $this->dbm->getCategoryFromTermin(Request::option('termin_id'));
			$t = $this->dbm->getTermin(Request::option('termin_id'));
		}

		if ($tmodus == "join" && !$this->dbm->has_joined(Request::option('termin_id')) && 
			!$this->dbm->max_persons_reached(Request::option('termin_id')) &&
                        ((!$this->dbm->is_already_booked($category_id,$GLOBALS['auth']->auth['uid']) && $this->dbm->is_unique_entry($category_id)) || !$this->dbm->is_unique_entry($category_id))
		) {
			$zusatz = trim(escapeshellcmd(basename($_REQUEST['zusatz'])));
			if ((!$c['enddate_admission'] || time() < $c['enddate_admission']) && (!$t['enddate_admission'] || time() < $t['enddate_admission'])) {
				if ($c["zusatz_active"] && $c["zusatz_mandatory"] && trim($_REQUEST['zusatz']) == "") {
					StudIPTemplateEngine::showErrorMessage(dgettext('tv',"Sie m&uuml;ssen die Zusatzangaben ausf&uuml;llen, um sich zu diesem Termin anmelden zu k&ouml;nnen!"));
				} else {
					$zusatz_ok = TRUE;
					if ($c['zusatz_verify']) {
						$vc = & $this->verify_classes[$c['zusatz_verify']];
						if (!$vc->verify($zusatz)) {
							$msg .= "error"."FEHLER: ".$vc->getErrorMessage().'';
							$zusatz_ok = FALSE;
						}
					}
					if ($zusatz_ok) {
						$this->dbm->add_myself_to_termin(Request::option('termin_id'), trim($_REQUEST['zusatz']));
						StudIPTemplateEngine::showSuccessMessage(dgettext('tv',"Sie haben sich zu diesem Termin eingetragen! Der Termin wurde au&szlig;erdem in Ihren pers&ouml;nlichen Terminkalender eingetragen."));
					} else {
						StudIPTemplateEngine::showErrorMessage(dgettext('tv',"Die eingegebenen Zusatzangaben sind nicht korrekt!"));
					}
				}
			} else {
				StudIPTemplateEngine::showErrorMessage(dgettext('tv',"Sie k&ouml;nnen sich nicht eintragen, der Anmeldezeitraum ist abgelaufen!"));
			}
			unset($tmodus);
		}
		if ($tmodus == "unjoin" && $this->dbm->has_joined(Request::option('termin_id'))) {
			if ($c && $t) {
				if ((!$c['enddate_admission'] || time() < $c['enddate_admission']) && (!$t['enddate_admission'] || time() < $t['enddate_admission'])) {
					$this->dbm->remove_person_from_termin(Request::option('termin_id'),$GLOBALS['auth']->auth['uid']);
					StudIPTemplateEngine::showSuccessMessage(dgettext('tv',"Sie haben sich erfolgreich ausgetragen!"));
				} else {
					StudIPTemplateEngine::showErrorMessage(dgettext('tv',"Sie k&ouml;nnen sich nicht austragen, der Abmeldezeitraum ist abgelaufen!"));
				}
			}
			unset($tmodus);
		}

		$this->show_public_termine($this->userid);
		
	}

	function actionAjaxDispatch(){
                ob_end_clean();
                if (!array_key_exists('ajax_cmd', $_REQUEST)) die;
                switch($_REQUEST['ajax_cmd']) {
			case 'do_seminar_search':
        	                $val = trim(basename(utf8_decode($_REQUEST['value'])));
                	        if ($val == "") return;
                        	echo json_encode(TVDBM::searchForSeminare($val));
	                        break;
			default: ;
                }
                die();
	}

}

?>
